// TODO: consider inlining all the functions

#ifndef __KERNEL_H__
#define __KERNEL_H__

#include <cmath>

#define PI 3.14159265f

class Kernel
{
public:
  static float WViscosity(float r, float h)
  {
    return 45.0f / (PI * pow(h, 6.0f)) * (h - r);
  }

  static float WPressure(float r, float h)
  {
    return 45.0f / (PI * pow(h, 6.0f)) * pow((h - r), 2.0f) / r;    
  }

  static float WPoly6(float r, float h)
  {
    return 315.0f / (64.0f * PI * pow(h, 9.0f)) * pow((h * h - r * r), 3.0f);    
  }
};

#endif