#ifndef __PARTICLE__
#define __PARTICLE__

#include "Eigen/Dense"

/* We use eigen (eigen.tuxfamily.org) to take advantage of SIMD instructions
   and also to simplify code involving vector operations */
struct Particle
{
public:
  unsigned int id; // from 0
  Eigen::Vector4f acceleration; // kgm/s^2
  Eigen::Vector4f position; // m
  Eigen::Vector4f velocity; // m/s
  Eigen::Vector4f prevVelocity;
  float density; // kg/m^3 
  float pressure; // kg/ms^2
  unsigned int neighborCount; // number of neighbors
  unsigned int zIndex; // z index

  EIGEN_MAKE_ALIGNED_OPERATOR_NEW
};

#endif