#ifndef __ULTILITIES_H__
#define __ULTILITIES_H__

/* This class contains methods to compute a morton code from three coordinates
   The code is from
   http://stackoverflow.com/questions/1024754/how-to-compute-a-3d-morton-number-interleave-the-bits-of-3-ints */
class Ultilities
{
public:  
  /* Given a 10-bit unsigned integer x, inserts two 0 bits between each
     pair of consecutive bits of x */
  inline static unsigned int SeparateBits(unsigned int x)
  {    
    x = (x | (x << 16u)) & 0x030000FFu;
    x = (x | (x <<  8u)) & 0x0300F00Fu;
    x = (x | (x <<  4u)) & 0x030C30C3u;
    x = (x | (x <<  2u)) & 0x09249249u;        
    return x;
  }

  /* Interleaves the bits of x, y, and z to get a z-index */
  inline static unsigned int EncodeMorton(unsigned int x, unsigned int y, unsigned int z)
  {
    return (SeparateBits(z) << 2u) | (SeparateBits(y) << 1u) | SeparateBits(x);
  }
};

#endif